
bm-prep () {
	t-tstunt-parsechangelog

	t-prep-newpackage example 1.0

	cd $p

	git checkout -b bad-build-deps indep-arch
	perl -pe 's/Build-Depends.*/$&, x-dgit-no-such-package/' \
		-i debian/control
	git commit -a -m bad-build-deps

	cat <<'END' >$tmp/stunt-git
#!/bin/sh -e
case "$*" in
*clean*) echo >&2 "BUILD-MODES PROGRAM git $*" ;;
esac
exec git "$@"
END
	chmod +x $tmp/stunt-git

	if zgrep 'dpkg-buildpackage: Make dependency checks fatal for -S' \
		/usr/share/doc/dpkg-dev/changelog.gz; then
			dpkgbuildpackage_deps_for_clean=true
	else
			dpkgbuildpackage_deps_for_clean=false
	fi

	cleanmodes_default="git none dpkg-source dpkg-source-d"
	cleanmodes_all="$cleanmodes_default git-ff check"
	cleanmodes="$cleanmodes_default"
}

bm-guess-e-source-e-targets () {
	local some_act=$1
	case "$some_act" in
	*" -b")	e_source=false;	e_targets='build binary'		;;
	*" -B")	e_source=false;	e_targets='build-arch binary-arch'	;;
	*" -A")	e_source=false;	e_targets='build-indep binary-indep'	;;
	*" -S")	e_source=true;	e_targets=' '				;;
	*" -F")	e_source=true;	e_targets='build binary'		;;
	*)	e_source=true;	e_targets='build binary'		;;
	esac
}


bm-report-source () {
	if "$@"; then
		echo >&4 "SOURCE EXISTS"
	else
		echo >&4 "SOURCE MISSING"
	fi
}

bm-build-deps-ok () {
	case "$branch" in
	indep-arch)		return 0	;;
	bad-build-deps)		return 1	;;
	esac
}

bm-compute-expected () {
	require_fail=unexpect # or required
	tolerate_fail=unexpect # or tolerate

	exec 4>$bmexp
	echo >&4 "$heading"

	case $cleanmode in
	git)		echo >&4 'BUILD-MODES PROGRAM git clean -xdf' ;;
	git-ff)		echo >&4 'BUILD-MODES PROGRAM git clean -xdff' ;;
	check)		echo >&4 'BUILD-MODES PROGRAM git clean -xdn' ;;
	dpkg-source-d)	echo >&4 "EXAMPLE RULES TARGET clean" ;;
	dpkg-source)	bm-build-deps-ok || tolerate_fail=tolerate
			echo >&4 "EXAMPLE RULES TARGET clean"
			;;
	none)		;;
	*)		fail "t-compute-expected-run $cleanmode ??" ;;
	esac

	if [ "x$e_targets" != x ]; then
		# e_targets can be " " to mean `/may/ fail due to b-d'
		bm-build-deps-ok || tolerate_fail=tolerate
	fi

	for t in $e_targets; do
		bm-build-deps-ok || require_fail=required
		echo >&4 "EXAMPLE RULES TARGET $t"
	done

	bm-report-source $e_source

	exec 4>&-
}

bm-run-one () {
	local args="--clean=$cleanmode $real_act"

	bmid="$act,$cleanmode,$branch"
	bmid=${bmid// /_}

	heading="===== [$bmid] dgit $args ====="

	bmlog=$tmp/run.$bmid.output
	bmexp=$tmp/run.$bmid.expected
	bmgot=$tmp/run.$bmid.results

	bm-compute-expected

	git checkout $branch
	git clean -xdf # since we might not do any actual cleaning

	dsc='../example_1.0.dsc'
	rm -f $dsc

	set +o pipefail
	t-dgit --git=$tmp/stunt-git $args 2>&1 | tee $bmlog
	local ps="${PIPESTATUS[*]}"
	set -o pipefail

	$bm_quirk_after_act

	exec 4>$bmgot
	echo >&4 "$heading"

	case $ps in
	"0 0")	actual_status=success ;;
	*" 0")	actual_status=failure; echo >&4 "OPERATION FAILED"; ;;
	*)	fail "tee failed" ;;
	esac

	case "$require_fail-$tolerate_fail-$actual_status" in
	required-********-failure) echo >>$bmexp "REQUIRED FAILURE" ;;
	********-tolerate-failure) echo >>$bmexp "TOLERATED FAILURE" ;;
	unexpect-********-success) ;;
	*)	fail "RF=$require_fail TF=$tolerate_fail AS=$actual_status" ;;
	esac

	egrep >&4 '^EXAMPLE RULES TARGET|^BUILD-MODES' $bmlog || [ $? = 1 ]

	bm-report-source [ -e $dsc ]

	exec 4>&-

	$bm_quirk_before_diff

	[ $actual_status = failure ] || diff -U10 $bmexp $bmgot
}

bm-act-iterate () {
	for cleanmode in $cleanmodes; do
		for branch in indep-arch bad-build-deps; do
			bm-run-one
		done
	done
	: bm-act-iterate done.
}
